<?php
rg_log("FILE: /inc/user/repo/bug/main");

$_bug_body = "";

$rg['can_save'] = $rg['login_ui']['uid'] > 0 ? 1 : 0;

$_op = empty($paras) ? "list" : array_shift($paras);
switch ($_op) {
case 'search':
	include($INC . "/user/repo/bug/search/search.php");
	$_bug_body .= $_bug_search;
	break;

case 'add':
	$_bug_body .= rg_bug_edit_high_level($db, $rg);
	break;

case 'list':
	// TODO: security: do I validate 'sparas' everywhere?!
	$_search = empty($paras) ? "All" : array_shift($paras);

	// Somebody pressed "Remove" (search) button?
	if (rg_var_uint("remove") == 1) {
		if (!rg_valid_referer()) {
			$_bug_body .= rg_warning("Error: invalid referer; try again");
			break;
		}

		if (!rg_token_valid($db, $rg, FALSE)) {
			$_bug_body .= rg_warning("Error: invalid token; try again."); // TODO
			break;
		}

		$_search_name = rg_var_str("name");
		$r = rg_bug_search_remove($db, $rg['ri']['repo_id'],
			$rg['login_ui']['uid'], $_search_name);
		if ($r === FALSE)
			$_bug_body .= rg_warning("Error: cannot delete search!"); // TODO
	}

	$r = rg_bug_search_load_all($db, $rg['ri']['repo_id'], $rg['login_ui']['uid']);
	if ($r === FALSE) {
		$_bug_body .= rg_warning("Error: cannot load all searches!"); // TODO
	} else {
		$_bug_body .= rg_template_table("repo/bug/search/list",
				$r, $rg);
	}

	$filter = rg_bug_search_load($db, $rg['ri']['repo_id'],
		$rg['login_ui']['uid'], $_search);
	if ($filter === FALSE) {
		$_bug_body .= rg_warning("Error: cannot load search!"); // TODO
		$filter = array();
	}

	if (isset($filter['name']))
		$rg['search_name'] = $filter['name'];

	$r = rg_bug_search($db, $rg['ri']['repo_id'], $rg['login_ui']['uid'], $filter);
	if ($r === FALSE) {
		// TODO: do something OK here!
		$_bug_body .= rg_warning("Error: Cannot search bugs!");
	} else {
		$_bug_body .= rg_template_table("repo/bug/list", $r, $rg);
	}

	// Show remove for custom search
	// TODO: don't we check for uid also? Security problems?
	if (isset($filter['standard']) && ($filter['standard'] == 0)) {
		$rg['rg_form_token'] = rg_token_get($db, $rg);
		$rg['search_remove_errmsg'] = "";
		$_bug_body .= rg_template("repo/bug/search/remove.html", $rg);
	}
	break;

default: // show - go directly to a bug
	$bug_id = intval($_op);
	$rg['bug'] = array();
	$rg['bug']['bug_id'] = $bug_id;
	if ($bug_id > 0) {
		$rg['bug']['url'] = $rg['url_repo'] . "/bug/"
			. $rg['bug']['bug_id'];
		include($INC . "/user/repo/bug/show/show.php");
		$_bug_body .= $_bug_show;
	}
	break;
}

$rg['HTML:bug_body'] = $_bug_body;
$bug_body = rg_template("repo/bug/main.html", $rg);
?>
