<?php
error_reporting(E_ALL | E_STRICT);
ini_set("track_errors", "On");

$INC = dirname(__FILE__) . "/../inc";
require_once(dirname(__FILE__) . "/config.php");
require_once($INC . "/init.inc.php");
require_once($INC . "/log.inc.php");
require_once($INC . "/sql.inc.php");
require_once($INC . "/struct.inc.php");
require_once($INC . "/state.inc.php");

rg_log_set_file("state.log");

require_once("common.php");

$rg_sql_debug = 1;

// check return for an invalid state
$r = rg_state_get($db, "asdsdsdf");
if ($r !== "") {
	echo "Cannot get '' (but '$r') for an unknown key!\n";
	exit(1);
}

$r = rg_state_set($db, "a", "bau");
if ($r !== TRUE) {
	echo "Cannot get a TRUE for setting 'a' to 'bau' ($r)!\n";
	exit(1);
}

$r = rg_state_set($db, "a", "cucu");
if ($r !== TRUE) {
	echo "Cannot get a TRUE for setting 'a' to 'cucu' ($r)!\n";
	exit(1);
}

$r = rg_state_get($db, "a");
if (strcmp($r, "cucu") != 0) {
	echo "Cannot get correct state ('$r' != 'cucu')!\n";
	exit(1);
}

rg_sql_close($db);

echo "state: OK!\n";
?>
